// tHgmFvO
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls,
  // Printers,    // v^o͉\tHg𗘗pꍇɕKv
  ExtCtrls ;

type
  TFontList = record
     fname : string ;
     ftype : integer ;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    FontList : array of TFontList ; // WindowsAPIpɕKvȕϐ
    FontListN: integer ;            // EEE
    function GetFontType(fontname:string) : integer ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// WindowsAPIp̃R[obN֐
function FontEnumProc(LogFont: PEnumLogFont; TextMetrics: PNewTextMetric;
                      FontType: Integer; lParam: LPARAM) : integer; stdcall;
begin
   Inc(Form1.FontListN);
   SetLength(Form1.FontList, Form1.FontListN);
   with Form1.FontList[Form1.FontListN-1] do begin
      fname := TEnumLogFont(LogFont^).elfLogFont.lfFaceName ;
      ftype := FontType ;
   end;
   Result := 1;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
var
   i : integer ;
begin
   With StringGrid1 do begin
      Cells[0,0] := 'tHg';
      Cells[1,0] := 'e';
      Cells[2,0] := 'tHg^Cv';
      for i:=0 to ColCount-1 do
         Cells[i,1] := '' ;
   end;
   // WindowsAPIp
   FontList := nil ;
   FontListN:= 0 ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // WindowsAPIp
   FontList := nil ;
end;

// [mF1]
procedure TForm1.Button1Click(Sender: TObject);
var
   sc : integer ;
   i,j : integer ;
   s : string ;
begin
   sc := Screen.Fonts.Count ;    // ʕ\\tHg
   // sc := Printer.Fonts.Count ;   // v^o͉\tHg
   With StringGrid1 do begin
      if (sc > 0) then
         RowCount := sc+1
      else
         for i:=0 to ColCount-1 do
            Cells[i,1] := '' ;

      for i:=0 to sc-1 do begin
         Cells[0,i+1] := Screen.Fonts[i] ;   // ʕ\\tHg
         // Cells[0,i+1] := Printer.Fonts[i] ;  // v^o͉\tHg
         j := GetFontType(Cells[0,i+1]);
         if ((j and 1) > 0) then s := '[σsb`]' else s := '[Œsb`]';
         if ((j and 2) > 0) then s := s + '[xN^]';
         if ((j and 4) > 0) then s := s + '[TrueType]';
         if ((j and 8) > 0) then s := s + 'foCX';
         Cells[2,i+1] := s ;
      end;
      Refresh ;
   end;
end;

// tHg̃^Cv擾
//    bit0: on:σsb` off:Œsb`
//    bit1: on:xN^tHg
//    bit2: on:TrueTypetHg
//    bit3: on:foCXtHg
function TForm1.GetFontType(fontname:string) : integer ;
var
   FontInfo : TTextMetric ;
   r : integer ;
begin
   r := 0 ;
   // Label2 _~[ɎgĂ܂
   Label2.Font.Name := fontname ;
   GetTextMetrics(Label2.Canvas.Handle, FontInfo);
   //
   with FontInfo do begin
      if ((tmPitchAndFamily and TMPF_FIXED_PITCH) > 0) then
         r := r or 1 ;
      if ((tmPitchAndFamily and TMPF_VECTOR) > 0) then
         r := r or 2 ;
      if ((tmPitchAndFamily and TMPF_TRUETYPE) > 0) then
         r := r or 4 ;
      if ((tmPitchAndFamily and TMPF_DEVICE) > 0) then
         r := r or 8 ;
   end;
   Result := r ;
end;

// ObhɊetHgł̕\
procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
   if (ACol = 1)and(ARow > 0) then begin
      with StringGrid1.Canvas do begin
         Font.Name := StringGrid1.Cells[0,ARow] ;
         Font.Size := 16 ;
         TextRect(Rect,Rect.Left+2,Rect.Top+2, Edit1.Text);
      end;
   end;
end;

// [mF2]
//    WindowsAPI𗘗pătHg̃Xg擾
procedure TForm1.Button2Click(Sender: TObject);
var
   i : integer ;
begin
   FontList := nil ;
   FontListN:= 0 ;
   EnumFontFamilies(Form1.Canvas.Handle, nil, @FontEnumProc, 0);
   With StringGrid1 do begin
      if (FontListN > 0) then
         RowCount := FontListN+1
      else
         for i:=0 to ColCount-1 do
            Cells[i,1] := '' ;

      for i:=0 to FontListN-1 do begin
         Cells[0,i+1] := FontList[i].fname ;
         Cells[2,i+1] := '' ;
         Case(FontList[i].ftype)of
         DEVICE_FONTTYPE:     Cells[2,i+1] := 'foCXtHg';
         RASTER_FONTTYPE:     Cells[2,i+1] := 'X^tHg';      // ̓rbg}bvtHg
         TRUETYPE_FONTTYPE:   Cells[2,i+1] := 'TrueTypetHg';
         end;
      end;
      Refresh ;
   end;
end;

end.
